<template>
  <q-select
    ref="select"
    v-model="value"
    multiple
    dense
    filled
    emit-value
    :options="props.options"
    :option-label="props.optionLabel"
  >
    <template #selected-item="scope">
      <q-chip
        dense
        square
        color="primary"
        text-color="white"
      >
        {{ scope.opt.name }}
      </q-chip>
    </template>
  </q-select>
</template>

<script lang='ts' setup>
import { ref, watch } from 'vue';
import { QSelect } from 'quasar';

interface Props {
  modelValue: any;
  options: any[];
  optionLabel?: string;
  alwaysHidePopup?: boolean;
}
const props = withDefaults(defineProps<Props>(), {
  optionLabel: 'name',
  alwaysHidePopup: false,
});

const emit = defineEmits<{
  (e: 'update:modelValue', value: any): void;
}>();

const select = ref<QSelect>();

const value = ref(props.modelValue);

watch(
  () => props.modelValue,
  (newVal) => {
    value.value = newVal;
  }
);

watch(value, (newVal) => {
  emit('update:modelValue', newVal);

  if (props.alwaysHidePopup) {
    select.value?.hidePopup();
  }
});
</script>
